#include "philo.h"

void	print_message(t_philo *philo, char *msg)
{
	long int		time_stamp;
	struct timeval	stime;
	char			*color;

	gettimeofday(&stime, NULL);
	time_stamp = (stime.tv_sec - philo->t_start_s) * 1000;
	time_stamp += (stime.tv_usec - philo->t_start_u) / 1000;
	color = WHITE;
	if (ft_strnstr(msg, "eating", ft_strlen(msg)))
		color = B_YELLOW;
	if (ft_strnstr(msg, "sleeping", ft_strlen(msg)))
		color = B_BLUE;
	if (ft_strnstr(msg, "thinking", ft_strlen(msg)))
		color = B_GREEN;
	pthread_mutex_lock(philo->m_print);
	ft_printf("%s%i %i %s%s\n", color, time_stamp, philo->p_nbr, msg, RESET);
	pthread_mutex_unlock(philo->m_print);
}

// long int t_start_s;
// long int t_start_u;
// long int t_last_meal_s;
// long int t_last_meal_u;
void	init_time(t_philo *philo)
{
	struct timeval	stime;

	gettimeofday(&stime, NULL);
	philo->t_start_s = stime.tv_sec;
	philo->t_start_u = stime.tv_usec;
}

void	update_time(t_philo *philo)
{
	struct timeval	stime;

	gettimeofday(&stime, NULL);
	philo->t_last_meal_s = stime.tv_sec;
	philo->t_last_meal_u = stime.tv_usec;
}

void	take_forks(t_philo *philo)
{
	pthread_mutex_lock(&(philo->m_fork));
	print_message(philo, "has taken a fork");
		pthread_mutex_lock(&(philo->next->m_fork));
		print_message(philo, "has taken a fork");

		print_message(philo, "is eating");
		usleep(philo->params->t_eat * 1000);

		pthread_mutex_unlock(&(philo->next->m_fork));
	pthread_mutex_unlock(&(philo->m_fork));
}

// int n_phi; // number_of_philosophers
// int t_die; // time_to_die
// int t_eat; // time_to_eat
// int t_slp; // time_to_sleep
// int n_eat; // [number_of_times_each_philosopher_must_eat]
void	*philo_exec(void *arg)
{
	t_philo	*philo;

	philo = (t_philo*)arg;
	init_time(philo);
	if (philo->p_nbr % 2 == 0)
		usleep(10 * 1000);
	while (1)
	{
		take_forks(philo);

		print_message(philo, "is sleeping");
		usleep(philo->params->t_slp * 1000);
		print_message(philo, "is thinking");
	}
	return (NULL);
}
